//(C)  2023 ""   Ren'PY rpa 
#include <windows.h>
#include <stdio.h>
#include <memory.h>

char main(int argc, char* argv[])
{
	if(argc < 3)
	{
		printf("Ren'PY rpa files extractor\nformat: rpaextract infile.rpa out_dir");
		return -1;
	}
	char *minfile = 0;
	size_t minfilesz = 0;
	{HANDLE hdlm;
	{HANDLE hdlf; 
	hdlf = CreateFile(argv[1], GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, 0, 0);
	hdlm = CreateFileMapping(hdlf, 0, PAGE_READONLY, 0, 0, "rpaextract");
	minfilesz = GetFileSize(hdlf, 0);
	CloseHandle(hdlf);
	//HANDLE hinfile = OpenFileMapping(FILE_MAP_READ, 0, argv[1]);
	if(!hdlf || !hdlm)
	{
exerrfopen:
		printf("fails to open %s file with error %i", argv[1], GetLastError());
		return 2;
	}}
	minfile = (char*) MapViewOfFile(hdlm, FILE_MAP_READ, 0, 0, 0);
	if(!minfile)
		goto exerrfopen;
	CloseHandle(hdlm);}
	CreateDirectory(argv[2], 0);
	{
		char *a, *b;
		size_t i, fs, psz;
		const char mt[18] = "Made with Ren'Py.";
		// .
		b = minfile;;
		do{
			b++;
			psz = minfilesz - (b - minfile);
			b = (char*)memchr(b, 'M', psz);
			if(!b)	break;
		}while(memcmp(b, mt, 17));
		if(!b)	return 0;
		// .
		for(i = 0; b && psz != 0; )
		{
			b += 17; // 
			a = b; //  
			// .
			b--;
			do{
				b++;
				psz = minfilesz - (b - minfile);
				b = (char*)memchr(b, 'M', psz);
				if(!b)	break;
			}while(memcmp(b, mt, 17));
			// .
			if(b)	//  b   
				fs = b - a; // .
			else
				fs = minfilesz - (a - minfile); // 
			// ...
			{
				char name[64], ext;
				const char extc[6][5] = {"dat\0", "png\0", "rpyc", "wav\0", "ogg\0", "jpg\0"};
				DWORD NumberOfBytesWritten;
				// 
				ext = 0;
				if(!memcmp(a, "PNG", 4))
					ext = 1;
				else if(!memcmp(a, "RENP", 4))
					ext = 2;
				else if(!memcmp(a, "RIFF", 4)) 
					ext = 3;
				else if(!memcmp(a, "OggS", 4)) 
					ext = 4;
				else if(!memcmp(a, "", 3))
					ext = 5;
				sprintf(name, "%s//block%04i.%s", argv[2], i++, extc[ext]);
				HANDLE hf = CreateFile(name, GENERIC_WRITE, 0, 0, CREATE_NEW, 0, 0);
				WriteFile(hf, a, fs, &NumberOfBytesWritten, 0);
				CloseHandle(hf);
			}
		}
	}
	UnmapViewOfFile(minfile);
	return 0;
}